% Calls the functions that perform alernating regression on the S-System defined in ToyNetwork.m
%
% alternating regression is performed as published in
% Chou I, Martens H, Voit EO: Parameter estimation in biochemical systems models with alternating regression. Theor Biol Med Model 2006, 3:25.
%
% Wolfgang Beyer, 2007

tic

% loads the time series data
load TS_clean.mat
% loads the results of performing autosmooth on the time series data
load TS_clean_AS.mat

%estimated slopes are the ones taken from autosmooth
Si1=result(:,6);
Si2=result(:,7);
Si3=result(:,8);
Si4=result(:,9);

%alternatively one could calculate the true slopes and use them
%uncomment the following lines if you want to use the true slopes

%Si1=[12*TS(:,4).^-.8 - 10*TS(:,2).^.5];
%Si2=[8*TS(:,2).^.5 - 3*TS(:,3).^.75];
%Si3=[3*TS(:,3).^.75 - 5*TS(:,4).^.5.*TS(:,5).^.2];
%Si4=[2*TS(:,2).^.5 - 6*TS(:,5).^.8];

%Set first estimation of degradation term and run alternating regression for X1
bd=[15; 1];
[Prod, Deg, Error, It] = AR_X1(TS(:,2), TS(:,4), Si1, bd)

%Set first estimation of degradation term and run alternating regression for X2
bd=[15; 1];
[Prod, Deg, Error, It] = AR_X2(TS(:,2), TS(:,3), Si2, bd)

%Set first estimation of degradation term and run alternating regression for X3
bd=[15; 1; 1];
[Prod, Deg, Error, It] = AR_X3(TS(:,3), TS(:,4), TS(:,5), Si3, bd)

%Set first estimation of degradation term and run alternating regression for X4
bd=[15; 1];
[Prod, Deg, Error, It] = AR_X4(TS(:,2), TS(:,5), Si4, bd)

%clear unused variables
clear Si1;
clear Si2;
clear Si3;
clear Si4;
clear bd;

toc
